#include<bits/stdc++.h>

struct Segment
{
    int a, b;

    Segment(int _a = 0, int _b = 0)
    {
        a = _a;
        b = _b;
    }

    void input()
    {
        std::cin >> a >> b;
    }
};

const int MAXN = 1e3 + 10;

int n, m;
Segment s[MAXN];
void input()
{
    std::cin >> n >> m;
    for (int i = 1; i <= m; i ++)
    s[i].input();
}

void impossible()
{
    std::cout << "impossible" << std::endl;
    exit(0);
}
int used[MAXN];
std::vector < int > covered[MAXN];

int c[MAXN];
bool inside(Segment s1, Segment s2)
{
    for (int i = 0; i <= n; i ++)
        c[i] = 0;
    if (s2.a <= s2.b)
        for (int i = s2.a; i <= s2.b; i ++)
            c[i] ++;
    else
    {
        for (int i = s2.a; i <= n; i ++)
            c[i] ++;
        for (int i = 1; i <= s2.b; i ++)
            c[i] ++;
    }

    if (s1.a <= s1.b)
        for (int i = s1.a; i <= s1.b; i ++)
            c[i] = 0;
    else
    {
        for (int i = s1.a; i <= n; i ++)
            c[i] = 0;
        for (int i = 1; i <= s1.b; i ++)
            c[i] = 0;
    }

    for (int i = 1; i <= n; i ++)
        if (c[i] > 0)
            return false;
    return true;
}
void simulate()
{
    for (int i = 1; i <= m; i ++)
    {
        if (s[i].a <= s[i].b)
        {
            for (int j = s[i].a; j <= s[i].b; j ++)
                covered[j].push_back(i);
        }
        else
        {
            for (int j = s[i].a; j <= n; j ++)
                covered[j].push_back(i);
            for (int j = 1; j <= s[i].b; j ++)
                covered[j].push_back(i);
        }
    }

    for (int i = 1; i <= n; i ++)
    {
        if (covered[i].size() < 2)
        {
            impossible();
        }
    }

    while(true)
    {
        bool done = true;
        for (int i = 1; i <= n; i ++)
        {
            int cnt[3];
            cnt[0] = cnt[1] = cnt[2] = 0;
            for (int id : covered[i])
                cnt[used[id]] ++;

            if (cnt[0] > 2)
                continue;
            if (cnt[1] > 0 && cnt[2] > 0)
                continue;
            
            if ((cnt[1] > 0 || cnt[2] > 0) && cnt[0] == 0)
            {
                impossible();
            }

            if ((cnt[1] + cnt[2] == 0) && cnt[0] == 2)
            {
                done = false;
                used[covered[i][0]] = 1;
                used[covered[i][1]] = 2;
                continue;
            }

            //std::cout << "assert " << cnt[1] << " " << cnt[2] << " " << cnt[0] << std::endl;
            if (cnt[1] + cnt[2] == 0)
                while(true);
            assert((cnt[1] > 0 || cnt[2] > 0) && cnt[0] == 1);
            int ls = 1;
            if (cnt[1] > 0)
                ls = 2;
            for (int id : covered[i])
            {
                if (used[id] == 0)
                {
                    used[id] = ls;
                    done = false;
                    break;
                    
                }
            }
            
        }

        if (done)
            break;
    }

    for (int i = 1; i <= m; i ++)
        for (int j = i + 1; j <= m; j ++)
        {
            if (used[i] == 2 || used[j] == 2)
                continue;
            if (inside(s[i], s[j]))
            {
                used[j] = 2;
                continue;
            }
            if (inside(s[j], s[i]))
            {
                used[i] = 2;
                continue;
            }
        }

    for (int i = 1; i <= n; i ++)
        if (used[i] == 0)
            used[i] = 1;    
}

int marked[2][MAXN];

void check_validity()
{
    for (int i = 1; i <= m; i ++)
    {
        Segment cur = s[i];
        if (cur.a <= cur.b)
        {
            for (int j = cur.a; j <= cur.b; j ++)
                marked[used[i] % 2][j] = 1;
        }
        else
        {
            for (int j = cur.a; j <= n; j ++)
                marked[used[i] % 2][j] = 1;
            for (int j = 1; j <= cur.b; j ++)
                marked[used[i] % 2][j] = 1;
        }
    }

    for (int i = 1; i <= n; i ++)
        if (!marked[0][i] || !marked[1][i])
            impossible();
    
    for (int i = 1; i <= m; i ++)
        std::cout << used[i] % 2;
    std::cout << std::endl;
}
void solve()
{
    input();
    simulate();
    check_validity();
}
int main()
{
    solve();
    return 0;
}