#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 300 + 10;
const llong INF = 1e18;

int n, m, k;
llong dp2[MAXN][MAXN]; // 2 sides
llong dp3[MAXN][MAXN]; // 3 sides
llong dp4[MAXN][MAXN]; // 4 sides
bool bl2[MAXN][MAXN];
bool bl3[MAXN][MAXN];
bool bl4[MAXN][MAXN];

llong f2(int row, int col)
{
    if (row == 0 || col == 0)
    {
        return 0;
    }

    if (bl2[row][col])
    {
        return dp2[row][col];
    }

    dp2[row][col] = INF;
    bl2[row][col] = true;
    for (int i = 1 ; i <= row ; ++i)
    {
        dp2[row][col] = std::min(dp2[row][col], f2(row - i, col) + 1LL * (i * col - k) * (i * col - k));
    }

    for (int i = 1 ; i <= col ; ++i)
    {
        dp2[row][col] = std::min(dp2[row][col], f2(row, col - i) + 1LL * (row * i - k) * (row * i - k));
    }

    return dp2[row][col];
}

llong f3(int row, int col) // row missing
{
    if (row == 0 || col == 0)
    {
        return 0;
    }

    if (bl3[row][col])
    {
        return dp3[row][col];
    }

    bl3[row][col] = true;
    dp3[row][col] = f2(row, col);

    for (int i = 1 ; i <= row ; ++i)
    {
        dp3[row][col] = std::min(dp3[row][col], f3(row - i, col) + 1LL * (i * col - k) * (i * col - k));
    }

    for (int colL = 1 ; colL <= col ; ++colL)
    {
        dp3[row][col] = std::min(dp3[row][col], f2(row, colL) + f2(row, col - colL));
        for (int colR = colL ; colR <= col ; ++colR)
        {
            dp3[row][col] = std::min(dp3[row][col], f2(row, colL - 1) + f2(row, col - colR) + 1LL * (row * (colR - colL + 1) - k) * (row * (colR - colL + 1) - k));
        }
    }

    return dp3[row][col];
}

llong f4(int row, int col)
{
    if (row == 0 || col == 0)
    {
        return 0;
    }

    if (bl4[row][col])
    {
        return dp4[row][col];
    }

    bl4[row][col] = true;
    dp4[row][col] = f3(row, col);

    for (int rowL = 1 ; rowL <= row ; ++rowL)
    {
        dp4[row][col] = std::min(dp4[row][col], f3(rowL, col) + f3(row - rowL, col));
        // for (int rowR = rowL ; rowR <= row ; ++rowR)
        // {
        //     dp4[row][col] = std::min(dp4[row][col], f3(rowL - 1, col) + f3(row - rowR, col) + 1LL * (col * (rowR - rowL + 1) - k) * (col * (rowR - rowL + 1) - k));
        // }
    }

    for (int colL = 1 ; colL <= col ; ++colL)
    {
        dp4[row][col] = std::min(dp4[row][col], f3(colL, row) + f3(col - colL, row));
        // for (int colR = colL ; colR <= col ; ++colR)
        // {
        //     dp4[row][col] = std::min(dp4[row][col], f3(rowL - 1, col) + f3(row - rowR, col) + 1LL * (col * (rowR - rowL + 1) - k) * (col * (rowR - rowL + 1) - k));
        // }
    }

    return dp4[row][col];
}

void solve()
{
    std::cout << f4(n, m) << '\n';
}

void input()
{
    std::cin >> n >> m >> k;
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}