#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <queue>

typedef long long llong;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n, m;
int l[MAXN];
int r[MAXN];
char sol[MAXN];
std::vector <std::pair <int,int>> byL[MAXN];
std::priority_queue <std::pair <int,int>> pq;

void solve()
{
    for (int mask = 0 ; mask < (1 << m) ; ++mask)
    {
        bool isOK = true;
        for (int i = 1 ; i <= n ; ++i)
        {
            bool have[2] = {false, false};
            for (int j = 1 ; j <= m ; ++j)
            {
                if (l[j] <= i && i <= r[j] && l[j] <= r[j])
                {
                    have[(mask & (1 << j - 1)) > 0] = 1;
                } else if (l[j] > r[j] && !(l[j] <= i && i <= r[j]))
                {
                    have[(mask & (1 << j - 1)) > 0] = 1;
                }
            }       

            if (!have[0] || !have[1])
            {
                isOK = false;
            }
        }

        if (isOK)
        {
            for (int i = 0 ; i < m ; ++i)
            {
                std::cout << ((mask & (1 << i)) > 0);
            }

            std::cout << '\n';
            return;
        }
    }

    std::cout << "impossible\n";
}

void input()
{
    std::cin >> n >> m;
    for (int i = 1 ; i <= m ; ++i)
    {
        std::cin >> l[i] >> r[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}