#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <queue>

typedef long long llong;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n, m;
int l[MAXN];
int r[MAXN];
char sol[MAXN];
std::vector <std::pair <int,int>> byL[MAXN];
std::priority_queue <std::pair <int,int>> pq;

void solve()
{
    for (int i = 1 ; i <= m ; ++i)
    {
        byL[l[i]].push_back({-r[i], i});
    }

    int addedTo = 0;
    int lPtr = 1, rPtr = 1;
    while (lPtr <= n || rPtr <= n)
    {
        int allowed = std::min(lPtr, rPtr);
        while (addedTo < allowed)
        {
            addedTo++;
            for (const auto &p : byL[addedTo])
            {
                pq.push({-p.first, p.second});
            }
        }

        if (lPtr <= rPtr)
        {
            while (pq.size() && -pq.top().first < lPtr)
            {
                pq.pop();
            }

            if (pq.empty())
            {
                std::cout << "impossible\n";
                return;
            }

            lPtr = -pq.top().first + 1;
            sol[pq.top().second] = '0';
            pq.pop();
        } else
        {
            while (pq.size() && -pq.top().first < lPtr)
            {
                pq.pop();
            }

            if (pq.empty())
            {
                std::cout << "impossible\n";
                return;
            }

            rPtr = -pq.top().first + 1;
            sol[pq.top().second] = '1';
            pq.pop();
        }
    }

    int allowed = std::min(lPtr, rPtr);
    while (addedTo < allowed)
    {
        addedTo++;
        for (const auto &p : byL[addedTo])
        {
            pq.push(p);
        }
    }
    
    while (pq.size())
    {
        sol[pq.top().second] = '0';
        pq.pop();
    }

    sol[m + 1] = '\0';
    std::cout << sol + 1 << '\n';
}

void input()
{
    std::cin >> n >> m;
    for (int i = 1 ; i <= m ; ++i)
    {
        std::cin >> l[i] >> r[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}