#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <queue>

typedef long long llong;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n, m;
int l[MAXN];
int r[MAXN];
char sol[MAXN];
std::vector <std::pair <int,int>> specialL[MAXN];
std::vector <std::pair <int,int>> specialR[MAXN];
std::vector <std::pair <int,int>> byL[MAXN];
std::priority_queue <std::pair <int,int>> pq;

void solve()
{
    for (int i = 1 ; i <= m ; ++i)
    {
        if (l[i] <= r[i]) byL[l[i]].push_back({r[i], i});
        else
        {
            specialL[r[i]].push_back({l[i], i});
            specialR[l[i]].push_back({r[i], i});
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        std::sort(specialL[i].begin(), specialL[i].end(), std::greater <std::pair <int,int>> ());
        std::sort(specialR[i].begin(), specialR[i].end(), std::greater <std::pair <int,int>> ());
    }

    int addedTo = 0;
    int neededL = n;
    int neededR = n;
    int lPtr = 1, rPtr = 1;

    while (lPtr <= neededL || rPtr <= neededR)
    {
        int allowed = n;
        if (lPtr <= neededL) allowed = std::min(allowed, lPtr);
        if (rPtr <= neededR) allowed = std::min(allowed, rPtr);
        while (addedTo < allowed)
        {
            addedTo++;
            for (const auto &p : byL[addedTo])
            {
                pq.push({-p.first, p.second});
            }
        }

        // std::cout << "here: " << lPtr << ' ' << rPtr << ' ' << neededL << ' ' << neededR << '\n';
        if ((rPtr > neededR) || (lPtr <= rPtr && lPtr <= neededL))
        {
            while (pq.size() && -pq.top().first < lPtr)
            {
                sol[pq.top().second] = '0';
                pq.pop();
            }

            if (pq.empty())
            {
                bool found = false;
                int idx = -1;
                
                for (int i = lPtr ; i <= n ; ++i)
                {
                    if (specialL[i].size() && (idx == -1 || specialL[i][0].first > specialL[idx][0].first))
                    {
                        idx = i;
                    }
                }

                if (idx != -1)
                {
                    sol[specialL[idx][0].second] = '0';
                    neededL = std::min(neededL, specialL[idx][0].first - 1);
                    lPtr = idx + 1;
                    found = true;
                    
                    for (int j = 0 ; j < specialR[specialL[idx][0].first].size() ; ++j)
                    {
                        if (specialR[specialL[idx][0].first][j].second == specialL[idx][0].second)
                        {
                            specialR[specialL[idx][0].first].erase(specialR[specialL[idx][0].first].begin() + j);
                            break;
                        }

                        assert(j + 1 < specialR[specialL[idx][0].first].size());
                    }

                    // std::cout << "take special r: " << rPtr << ": " << i << ' ' << specialL[i][0].first << '\n';
                    specialL[idx].erase(specialL[idx].begin());
                }

                if (found)
                {
                    continue;
                }

                for (int i = 1 ; i <= lPtr ; ++i)
                {
                    if (specialR[i].size())
                    {
                        for (int j = 0 ; j < specialL[specialR[i][0].first].size() ; ++j)
                        {
                            if (specialL[specialR[i][0].first][j].second == specialR[i][0].second)
                            {
                                specialL[specialR[i][0].first].erase(specialL[specialR[i][0].first].begin() + j);
                                break;
                            }

                            assert(j + 1 < specialR[specialL[i][0].first].size());
                        }

                        // std::cout << "full cover l: " << lPtr << ": " << specialR[i][0].first << ' ' << i << '\n';
                        sol[specialR[i][0].second] = '0';
                        specialR[i].erase(specialR[i].begin());
                        found = true;
                        lPtr = n + 1;
                        break;
                    }
                }

                if (found)
                {
                    continue;
                }

                std::cout << "impossible\n";
                return;
            }

            lPtr = -pq.top().first + 1;
            sol[pq.top().second] = '0';
            // std::cout << "take normal L: " << pq.top().second << '\n';
            pq.pop();
        } else
        {
            while (pq.size() && -pq.top().first < rPtr)
            {
                sol[pq.top().second] = '0';
                pq.pop();
            }

            if (pq.empty())
            {
                bool found = false;
                int idx = -1;

                for (int i = rPtr ; i <= n ; ++i)
                {
                    if (specialL[i].size() && (idx == -1 || specialL[i][0].first > specialL[idx][0].first))
                    {
                        idx = i;
                    }
                }

                if (idx != -1)
                {
                    sol[specialL[idx][0].second] = '1';
                    neededR = std::min(neededR, specialL[idx][0].first - 1);
                    rPtr = idx + 1;
                    found = true;
                    
                    for (int j = 0 ; j < specialR[specialL[idx][0].first].size() ; ++j)
                    {
                        if (specialR[specialL[idx][0].first][j].second == specialL[idx][0].second)
                        {
                            specialR[specialL[idx][0].first].erase(specialR[specialL[idx][0].first].begin() + j);
                            break;
                        }

                        assert(j + 1 < specialR[specialL[idx][0].first].size());
                    }

                    // std::cout << "take special r: " << rPtr << ": " << i << ' ' << specialL[i][0].first << '\n';
                    specialL[idx].erase(specialL[idx].begin());
                }

                if (found)
                {
                    continue;
                }

                for (int i = 1 ; i <= rPtr ; ++i)
                {
                    if (specialR[i].size())
                    {
                        for (int j = 0 ; j < specialL[specialR[i][0].first].size() ; ++j)
                        {
                            if (specialL[specialR[i][0].first][j].second == specialR[i][0].second)
                            {
                                specialL[specialR[i][0].first].erase(specialL[specialR[i][0].first].begin() + j);
                                break;
                            }

                            assert(j + 1 < specialR[specialL[i][0].first].size());
                        }

                        // std::cout << "full cover r: " << rPtr << ": " << specialR[i][0].first << ' ' << i << '\n';
                        sol[specialR[i][0].second] = '1';
                        specialR[i].erase(specialR[i].begin());
                        found = true;
                        rPtr = n + 1;
                        break;
                    }
                }

                if (found)
                {
                    continue;
                }

                std::cout << "impossible\n";
                return;
            }
            
            // std::cout << "take normal R: " << pq.top().second << '\n';
            rPtr = -pq.top().first + 1;
            sol[pq.top().second] = '1';
            pq.pop();
        }
    }

    int allowed = std::min(lPtr, rPtr);
    while (addedTo < allowed)
    {
        addedTo++;
        for (const auto &p : byL[addedTo])
        {
            pq.push(p);
        }
    }
    
    // std::cout << "in the end: " << lPtr << ' ' << rPtr << ' ' << neededL << ' ' << neededR << '\n';
    for (int i = 1 ; i <= m ; ++i)
    {
        if (sol[i] != '0' && sol[i] != '1')
        {
            sol[i] = '0';
        }
    }

    sol[m + 1] = '\0';
    std::cout << sol + 1 << '\n';
}

void input()
{
    std::cin >> n >> m;
    for (int i = 1 ; i <= m ; ++i)
    {
        std::cin >> l[i] >> r[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}