#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <cassert>
#include <cmath>
#include <stack>

#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")

typedef long long llong;
const int MAXN = 100;
const int INF  = 1e9;

int n = 1;
int cntLeaves;
struct Equation
{
    int vals[MAXN];
    friend Equation operator * (Equation e, int num)
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            e.vals[i] *= num;
        }

        return e;
    }

    friend void operator += (Equation &e, Equation e2)
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            e.vals[i] += e2.vals[i];
        }
    }

    friend void operator -= (Equation &e, Equation e2)
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            e.vals[i] -= e2.vals[i];
        }
    }
};

int sum[MAXN];
int perm[MAXN];
Equation tree[MAXN];
Equation toSolve[MAXN];
std::vector <std::pair <int,int>> g[MAXN];
std::string s;

int ptr;
bool shouldSet[MAXN];
void dfs(int node)
{
    if (g[node].empty())
    {
        shouldSet[node] = 1;
        tree[node].vals[node] = 1;
        return;
    }

    for (const auto &[u, dist] : g[node])
    {   
        // std::cout << "edge: " << node << ' ' << u << ' ' << dist << '\n';     
        dfs(u);
        tree[node] += tree[u];
        toSolve[node] += tree[u] * (int)dist;
    }

    // std::cout << "to solve: " << node << '\n';
    // for (int i = 1 ; i <= n ; ++i)
    // {
    //     std::cout << toSolve[node].vals[i] << ' ';
    // }

    // std::cout << '\n';
}   

int values[MAXN];
std::string ans;
void sol(int node)
{
    if (g[node].empty())
    {
        std::string toAdd;
        int num = values[node];
        while (num > 0)
        {
            toAdd += '0' + num % 10;
            num /= 10;
        }

        std::reverse(toAdd.begin(), toAdd.end());
        ans += toAdd;
        return;
    }

    ans += '(';
    for (int i = 0 ; i < g[node].size() ; ++i)
    {
        sol(g[node][i].first);
        if (i + 1 < g[node].size())
        {
            ans += ',';
        }
    }

    ans += ')';
}

bool taken[MAXN];
bool rec(int row, int col)
{
    if (row == 0)
    {
        return true;
    }

    if (col == 0)
    {
        int res = 0;
        for (int i = 1 ; i <= n ; ++i)
        {
            res += toSolve[row].vals[i] * values[i];
        }

        // std::cout << "not sucess: " << row << '\n'
        // if (fabs(res) > 1e-5 && row == 5 && taken[9] && taken[4] && taken[7] && values[15] == 3 && values[16] == 2)
        // {
        //     std::cout << "          unsucess: " << row << ' ' << taken[9] << ' ' << taken[4] << ' ' << taken[7] << '\n';
        //     for (int i = 1 ; i <= n ; ++i)
        //     {
        //         std::cout << i << ' ' << toSolve[row].vals[i] << ' ' << values[i] << '\n';
        //     }
        // }
        if (res != 0) return false;
        // if (row == 5)
        // {
        //     std::cout << "sucess: " << row << ' ' << taken[9] << ' ' << taken[4] << ' ' << taken[7] << '\n';
        //     for (int i = 1 ; i <= n ; ++i)
        //     {
        //         std::cout << i << ' ' << toSolve[row].vals[i] << ' ' << values[i] << '\n';
        //     }
            
        //     // if (taken[9] && taken[4] && taken[7])
        //     // {
        //     //     rec(row - 1, n);
        //     //     exit(0);
        //     // }
        // }
        return rec(row - 1, n);
    }

    if (!shouldSet[col] || toSolve[row].vals[col] == 0 || values[col] != 0)
    {
        // if (row == 4) std::cout << "skip for 4: " << col << ' ' << values[col] << '\n';
        return rec(row, col - 1);
    }

    for (int i = 1 ; i <= cntLeaves ; ++i)
    {
        if (!taken[i])
        {
            values[col] = i;
            taken[i] = true;
            // if (row ==4 && col == 12 && i == 4 && values[col + 1] == 7 && values[15] == 3 && values[16] == 2)
            // {
            //     std::cout << "should be trying???\n";
            // }
            if (rec(row, col - 1))
            {
                return true;
            }

            values[col] = 0;
            taken[i] = false;
        }
    }

    return false;
}

void solve()
{
    std::stack <int> nodes;

    int value = 0;
    bool isNegative = false;
    bool lastIsClosing = false;
    for (const char &c : s)
    {
        if (c == ' ')
        {
            continue;
        }

        if (c == '(')
        {
            if (n != 1)
            {
                g[nodes.top()].push_back({n, (isNegative ? -value : value)});
                value = 0;
                isNegative = false;
            }

            nodes.push(n);
            n++;
            lastIsClosing = false;
            continue;
        }

        if (c == ')')
        {
            if (!lastIsClosing)
            {
                g[nodes.top()].push_back({n, (isNegative ? -value : value)});
                n++;
                value = 0;
                isNegative = false;            
                lastIsClosing = true;
            }

            nodes.pop();
            continue;
        }

        if (c == ',')
        {
            if (lastIsClosing)
            {
                lastIsClosing = false;
                continue;
            }

            g[nodes.top()].push_back({n, (isNegative ? -value : value)});
            n++;
            value = 0;
            isNegative = false;
            lastIsClosing = false;
            continue;
        }

        if (c == '-')
        {
            isNegative = true;
            lastIsClosing = false;
            continue;
        }

        if (isdigit(c))
        {
            value = 10 * value + c - '0';
            lastIsClosing = false;
            continue;
        }

        assert(false);
    }

    n--;
    for (int i = 1 ; i <= n ; ++i)
    {
        cntLeaves += (g[i].empty());
    }

    dfs(1);

    // std::cout << "before\n";
    // for (int i = 1 ; i <= n ; ++i)
    // {
    //     for (int j = 1 ; j <= n ; ++j)
    //     {
    //         std::cout << toSolve[i].vals[j] << ' ';
    //     }

    //     std::cout << '\n';
    // }

    // int row = 1;
    // for (int i = 1 ; i <= n ; ++i)
    // {
    //     for (int j = row ; j <= n ; ++j)
    //     {
    //         if (toSolve[j].vals[i] > 0)
    //         {
    //             std::swap(toSolve[j], toSolve[row]);
    //             break;
    //         }
    //     }

    //     if (toSolve[row].vals[i] == 0)
    //     {
    //         continue;
    //     }

    //     // std::cout << "here: " << toSolve[row].vals[i] << '\n';
    //     for (int j = 1 ; j <= n ; ++j)
    //     {
    //         if (row == j || toSolve[j].vals[i] == 0) continue;
    //         toSolve[j] -= toSolve[row] * (((int)toSolve[j].vals[i]) / ((int)toSolve[row].vals[i]));
    //         // std::cout << "here: " << toSolve[j].vals[i] << ' ' << toSolve[row].vals[i] << ' ' << (((int)toSolve[j].vals[i]) / ((int)toSolve[row].vals[i])) << '\n';
    //     }

    //     row++;
    // }

    // std::sort(toSolve + 1, toSolve + 1 + n);
    // std::cout << "after\n";
    // for (int i = 1 ; i <= n ; ++i)
    // {
    //     for (int j = 1 ; j <= n ; ++j)
    //     {
    //         std::cout << toSolve[i].vals[j] << ' ';
    //     }

    //     std::cout << '\n';
    // }

    // std::cout << "cnt leaves: " << cntLeaves << '\n';
    rec(n, n);
    sol(1);

    std::cout << ans << '\n';
}   

void input()
{
    std::cin >> s;
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}

/*
(-3,-1,2(-2,-1,1))

(-3(-1(-1(-1,1,2),3),2),3(-2,1,2),6(-2,3))

(-8,-4(-5,-3,-1,1),-2(-1,1,3),2(-1(-3,-2,1(-2,1,3)),1,3),6)
*/