#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

struct segment{
    int from,to,id;
};

int n,m,a[MAXN],b[MAXN],l,r;

int tree[4*MAXN],lazy[4*MAXN];
bool sol[MAXN];

segment t[4*MAXN],best[MAXN];

void reset(){
    for(int i=1;i<=2000;i++){
        best[i]=t[i]={0,0,0};
        tree[i]=lazy[i]=0;

        sol[i]=false;
    }
}

void psh(int v){
    if(lazy[v]==0)return;

    tree[2*v]+=lazy[v];
    tree[2*v+1]+=lazy[v];

    lazy[2*v]+=lazy[v];
    lazy[2*v+1]+=lazy[v];

    lazy[v]=0;
}

void update(int v,int l,int r,int ll,int rr,int val){
    if(ll>rr)return;
    if(l==ll and r==rr){
        tree[v]+=val;
        lazy[v]+=val;
    }else{
        int tt=(l+r)/2;
        psh(v);

        update(2*v,l,tt,ll,min(tt,rr),val);
        update(2*v+1,tt+1,r,max(tt+1,ll),rr,val);

        tree[v]=max(tree[2*v],tree[2*v+1]);
    }
}

int getpos(int v,int l,int r,int pos){
    if(l==r)return tree[v];

    int tt=(l+r)/2;
    psh(v);

    if(pos<=tt)return getpos(2*v,l,tt,pos);
    return getpos(2*v+1,tt+1,r,pos);
}

int findpos(int v,int l,int r){
    if(l==r)return l;

    int tt=(l+r)/2;
    psh(v);

    if(tree[2*v]>1)return findpos(2*v,l,tt);
    return findpos(2*v+1,tt+1,r);
}

int firstpos(int v,int l,int r,int ll,int rr){
    if(ll>rr)return n+1;

    if(l==ll and r==rr){
        if(tree[v]>1)return findpos(v,l,r);
        return n+1;
    }else{
        int tt=(l+r)/2;
        psh(v);

        int curr=firstpos(2*v,l,tt,ll,min(tt,rr));
        if(curr<=n)return curr;

        return firstpos(2*v+1,tt+1,r,max(tt+1,ll),rr);
    }
}

segment combine(segment fr,segment sc){
    if(fr.to>sc.to)return fr;
    return sc;
}

void build(int v,int l,int r){
    if(l==r){
        t[v]=best[l];
    }else{
        int tt=(l+r)/2;
        build(2*v,l,tt);
        build(2*v+1,tt+1,r);

        t[v]=combine(t[2*v],t[2*v+1]);
    }
}

segment findmax(int v,int l,int r,int ll,int rr){
    if(ll>rr)return {0,0,0};
    if(l==ll and r==rr){
        return t[v];
    }else{
        int tt=(l+r)/2;
        return combine( findmax(2*v,l,tt,ll,min(tt,rr)) , findmax(2*v+1,tt+1,r,max(tt+1,ll),rr) );
    }
}

int main(){

    cin>>n>>m;

    for(int i=1;i<=m;i++){
        cin>>a[i]>>b[i];

        if(a[i]>b[i])swap(a[i],b[i]);

        if(b[i]>best[a[i]].to){
            best[a[i]]={a[i],b[i],i};
        }

        update(1,1,n,a[i],b[i],1);
    }

    build(1,1,n);

    l=1; r=0;
    while(r<n){
        int from=firstpos(1,1,n,l,r+1);

        if(from==n+1){
            cout<<"impossible\n";
            return 0;
        }

        segment maxseg=findmax(1,1,n,from,r+1);

        if(maxseg.from==0){
            cout<<"impossible\n";
            return 0;
        }

        update(1,1,n,maxseg.from,maxseg.to,-1);

        l=maxseg.from+1; r=maxseg.to;
        sol[maxseg.id]=true;
    }

    for(int i=1;i<=4*n;i++)tree[i]=lazy[i]=0;

    for(int i=1;i<=m;i++){
        if(!sol[i])update(1,1,n,a[i],b[i],1);
    }

    for(int i=1;i<=n;i++){
        if(getpos(1,1,n,i)==0){
            cout<<"impossible\n";
            return 0;
        }
    }

    for(int i=1;i<=m;i++){
        if(sol[i])cout<<"1";
        else cout<<"0";
    }

    cout<<"\n";

    return 0;
}