#include<bits/stdc++.h>
#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")
#define MAXN 100007
using namespace std;

struct segment{
    int from,to,id;
};

int n,m,a[MAXN],b[MAXN],l,r;

int tree[4*MAXN],lazy[4*MAXN];
bool sol[MAXN];

segment t[4*MAXN],best[MAXN];

void reset(){
    for(int i=1;i<=4*n;i++){
        t[i]={0,0,0};
        tree[i]=lazy[i]=0;
    }

    for(int i=1;i<=n;i++){
        best[i]={0,0,0};
        sol[i]=0;
    }
}

void psh(int v){
    if(lazy[v]==0)return;

    tree[2*v]+=lazy[v];
    tree[2*v+1]+=lazy[v];

    lazy[2*v]+=lazy[v];
    lazy[2*v+1]+=lazy[v];

    lazy[v]=0;
}

void update(int v,int l,int r,int ll,int rr,int val){
    if(ll>rr)return;
    if(l==ll and r==rr){
        tree[v]+=val;
        lazy[v]+=val;
    }else{
        int tt=(l+r)/2;
        psh(v);

        update(2*v,l,tt,ll,min(tt,rr),val);
        update(2*v+1,tt+1,r,max(tt+1,ll),rr,val);

        tree[v]=min(tree[2*v],tree[2*v+1]);
    }
}

int getmin(int v,int l,int r,int ll,int rr){
    if(ll>rr)return n+1;
    if(l==ll and r==rr){
        return tree[v];
    }else{
        int tt=(l+r)/2;
        psh(v);

        return min( getmin(2*v,l,tt,ll,min(tt,rr)) , getmin(2*v+1,tt+1,r,max(tt+1,ll),rr) );
    }
}

int getpos(int v,int l,int r,int pos){
    if(l==r)return tree[v];

    int tt=(l+r)/2;
    psh(v);

    if(pos<=tt)return getpos(2*v,l,tt,pos);
    return getpos(2*v+1,tt+1,r,pos);
}

segment combine(segment fr,segment sc){
    if(fr.to>sc.to)return fr;
    return sc;
}

void build(int v,int l,int r){
    if(l==r){
        t[v]=best[l];
    }else{
        int tt=(l+r)/2;
        build(2*v,l,tt);
        build(2*v+1,tt+1,r);

        t[v]=combine(t[2*v],t[2*v+1]);
    }
}

segment findmax(int v,int l,int r,int ll,int rr){
    if(ll>rr)return {0,0,0};
    if(l==ll and r==rr){
        return t[v];
    }else{
        int tt=(l+r)/2;
        return combine( findmax(2*v,l,tt,ll,min(tt,rr)) , findmax(2*v+1,tt+1,r,max(tt+1,ll),rr) );
    }
}

bool solve(){
    reset();

    for(int i=1;i<=m;i++){
        if(a[i]<=b[i]){
            if(b[i]>best[a[i]].to){
                best[a[i]]={a[i],b[i],i};
            }
            update(1,1,n,a[i],b[i],1);
        }else{
            if(n>best[a[i]].to){
                best[a[i]]={a[i],n,i};
            }

            update(1,1,n,a[i],n,1);
            update(1,1,n,1,b[i],1);
        }
    }

    build(1,1,n);

    l=1; r=0;
    while(r<n){
        int from=r+1;
        int to=r;

        int lt=l-1,rt=r+1,mid;
        while(lt+1<rt){
            mid=(lt+rt)/2;
            if(getmin(1,1,n,mid,r)>=2){
                rt=mid;
            }else{
                lt=mid;
            }
        }

        from=rt;

        if(getpos(1,1,n,to+1)>=2)to++;

        if(r==0)from=1;

        if(from>to)return false;

        segment maxseg=findmax(1,1,n,from,to);

        if(maxseg.from==0)return false;

        update(1,1,n,maxseg.from,maxseg.to,-1);

        l=maxseg.from+1; r=maxseg.to;
        sol[maxseg.id]=true;
    }

    return true;

}

void shift(int x){
    for(int i=1;i<=m;i++){
        a[i]-=x; b[i]-=x;

        if(a[i]<1)a[i]+=n;
        if(b[i]<1)b[i]+=n;

        if(a[i]>n)a[i]-=n;
        if(b[i]>n)b[i]-=n;
    }
}

void prnt(){
    for(int i=1;i<=m;i++){
        if(sol[i])cout<<"1";
        else cout<<"0";
    }
    cout<<"\n";
    exit(0);
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    for(int i=1;i<=m;i++){
        cin>>a[i]>>b[i];
    }

    for(int i=1;i<=8;i++){
        shift(a[i]-1);
        if(solve())prnt();
        shift(-a[i]+1);
    }

    cout<<"impossible\n";
    
    return 0;
}