#include<bits/stdc++.h>
#define MAXN 2000007
using namespace std;

const long long inf=1'000'000'000'000'000'000;

struct line{
    int from,to,id;

    inline friend bool operator < (line fr,line sc){
        return fr.to<sc.to;
    }
};

int n,x,pos;
int a[MAXN],to[MAXN],jump[MAXN];

priority_queue<line> q;
vector< pair<int,long long> > tree[MAXN];
vector<int> ids;

int cost(int x,int y){
    if(y==0)return 0;
    return min(y+a[y],n) - min(x+a[x],n);
}

bool cmp(int x,int y){
    return min(n,x+a[x])<min(n,y+a[y]);
}

void build_tree(){
    ids.clear();

    for(int i=1;i<=n;i++){
        q.push({max(1,i-a[i]),min(n,i+a[i]),i});
        ids.push_back(i);
    }

    sort(ids.begin(),ids.end(),cmp);
    reverse(ids.begin(),ids.end());

    for(int i:ids){
        while(!q.empty() and q.top().from>i+a[i]+1){
            q.pop();
        }
        
        if(i+a[i]>=n)to[i]=0;
        else to[i]=q.top().id;
    }

    for(int i=1;i<=n;i++){
        tree[to[i]].push_back({i,cost(i,to[i])});
    }

    while(!q.empty())q.pop();
    for(int i=1;i<=n;i++){
        q.push({max(1,i-a[i]),min(n,i+a[i]),i});
    }

    for(int i=n;i>=1;i--){
        while(!q.empty() and q.top().from>i){
            q.pop();
        }

        jump[i]=q.top().id;
    }

    for(int i=1;i<=n;i++){
        tree[jump[i]].push_back({n+i, min(n,a[jump[i]]+jump[i])-(i-1) });
    }

    while(!q.empty())q.pop();
}

long long dist[MAXN],dep[MAXN],ans,pref[MAXN],maxs;

void dfs(int x,long long dep,long long sum,long long s){
    dist[x]=sum-(dep+1)*s;

    for(int i=0;i<tree[x].size();i++){
        dfs(tree[x][i].first,dep-1,sum+dep*tree[x][i].second,s+tree[x][i].second);
    }
}

void reset(){
    for(int i=1;i<=n;i++)tree[i].clear();
}

void solve(){
    reset();

    build_tree();
    dfs(0,n,0,0);

    long long res=0;
    for(int i=n+1;i<=2*n;i++){
        res+=dist[i];
    }

    ans=min(ans,res);
}

void sim(int pos){
    int s=a[pos];
    a[pos]=x;
    solve();
    a[pos]=s;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>x;

    for(int i=1;i<=n;i++){
        cin>>a[i];
    }

    ans=inf;
    solve();

    for(int i=n+1;i<=2*n;i++){
        pref[i]=pref[i-1]+dist[i];
    }

    for(int i=n+1;i<=2*n;i++){
        if(pref[max(2*n,i+x)]-pref[min(n+1,i-x)-1]>maxs){
            maxs=pref[max(2*n,i+x)]-pref[min(n+1,i-x)-1];
            pos=i-n;
        }
    }

    sim(pos);
    sim(min(pos+1,n));
    sim(max(pos-1,1));

    cout<<ans<<"\n";

    return 0;
}

/*
10 0
0 1 0 0 2 0 1 3 0 1

*/