#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=4e5+5;
const int MAXLOG=20;

int n;
int a[MAXN];
vector<int> adj[MAXN];
int lp[MAXN];
vector<int> v[MAXN];
int par[MAXN][MAXLOG];
int divs;
int depth[MAXN];
int ans=0;

void sieve(int mx)
{
    lp[1]=1;
    for(int i=2;i<=mx;i++)
    {
        if(!lp[i])
        {
            lp[i]=i;
            if((long long)i*i>mx) continue;
            for(int j=i*i;j<=mx;j+=i)
            {
                lp[j]=i;
            }
        }
    }
}

void dfs(int v)
{
    for(auto u: adj[v])
    {
        if(u==par[v][0]) continue;
        par[u][0]=v;
        depth[u]=depth[v]+1;
        dfs(u);
    }
}

int lca(int u,int v)
{
    if(depth[u]>depth[v]) swap(u,v);
    int diff=depth[v]-depth[u];
    for(int i=0;i<MAXLOG;i++)
    {
        if(diff&(1<<i)) v=par[v][i];
    }

    if(u==v) return u;

    for(int i=MAXLOG-1;i>=0;i--)
    {
        if(par[u][i]!=par[v][i])
        {
            u=par[u][i];
            v=par[v][i];
        }
    }
    return par[u][0];
}

int dist(int u,int v)
{
    int t=lca(u,v);
    return depth[u]+depth[v]-2*depth[t];
}

int dfs2(int v)
{
    int max1=0, max2=0;
    for(auto u: adj[v])
    {
        if(u==par[v][0]) continue;
        int cur=dfs2(u);
        if(cur>max1)
        {
            max2=max1;
            max1=cur;
        }
        else if(cur>max2) max2=cur;
    }
    if(max1 && max2) ans=max(ans, max1+max2-2*depth[v]);
    else if(max1 && a[v]%divs==0) ans=max(ans, max1-depth[v]);
    if(max1==0 && a[v]%divs==0) max1=depth[v];
    return max1;
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n;
for(int i=1;i<=n;i++) cin>>a[i];
for(int i=1;i<n;i++)
{
    int u,v;
    cin>>u>>v;
    adj[u].push_back(v);
    adj[v].push_back(u);
}

int mx=(*max_element(a+1,a+n+1));
sieve(mx);

for(int i=1;i<=n;i++)
{
    int x=a[i];
    while(x>1)
    {
        int d=lp[x];
        v[d].push_back(i);
        while(lp[x]==d) x/=d;
    }
}

int root=1;

par[root][0]=0;
depth[root]=1;
dfs(root);
for(int i=1;(1<<i)<n;i++)
{
    for(int j=1;j<=n;j++)
    {
        par[j][i]=par[par[j][i-1]][i-1];
    }
}

int bl=500;

for(int i=2;i<=mx;i++)
{
    if(v[i].size()<bl)
    {
        for(int j=0;j<v[i].size();j++)
        {
            for(int k=j+1;k<v[i].size();k++)
            {
                ans=max(ans, dist(v[i][j], v[i][k]));
            }
        }
    }
    else
    {
        divs=i;
        dfs2(root);
    }
}

cout<<ans<<endl;

return 0;
}
