#pragma GCC Optimize("Ofast")
#pragma GCC target ("sse4")

#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=4e5+5;
const int MAXLOG=20;

int n;
int a[MAXN];
vector<int> adj[MAXN];
int lp[MAXN];
vector<int> v[MAXN];
int spt[MAXN][MAXLOG];
int par[MAXN];
int divs;
int depth[MAXN];
int order[2*MAXN];
int tin[MAXN];
int pw[MAXN];
int t=1;
int ans=0;

void sieve(int mx)
{
    lp[1]=1;
    for(int i=2;i<=mx;i++)
    {
        if(!lp[i])
        {
            lp[i]=i;
            if((long long)i*i>mx) continue;
            for(int j=i*i;j<=mx;j+=i)
            {
                lp[j]=i;
            }
        }
    }
}

void dfs(int v)
{
    order[t]=depth[v];
    tin[v]=t++;
    for(auto u: adj[v])
    {
        if(u==par[v]) continue;
        par[u]=v;
        depth[u]=depth[v]+1;
        dfs(u);
        order[t++]=depth[v];
    }
}

int lca(int u,int v)
{
    int p=pw[tin[v]-tin[u]+1];
    return min(spt[tin[u]][p], spt[tin[v]-(1<<p)+1][p]);
}

int dist(int u,int v)
{
    if(tin[u]>tin[v]) swap(u,v);
    int lcaDepth=lca(u,v);
    //cout<<u<<" "<<v<<" "<<depth[u]<<" "<<depth[v]<<" "<<lcaDepth<<endl;
    return depth[u]+depth[v]-2*lcaDepth;
}

int dfs2(int v)
{
    int max1=0, max2=0;
    for(auto u: adj[v])
    {
        if(u==par[v]) continue;
        int cur=dfs2(u);
        if(cur>max1)
        {
            max2=max1;
            max1=cur;
        }
        else if(cur>max2) max2=cur;
    }
    if(max1 && max2) ans=max(ans, max1+max2-2*depth[v]);
    else if(max1 && a[v]%divs==0) ans=max(ans, max1-depth[v]);
    if(max1==0 && a[v]%divs==0) max1=depth[v];
    return max1;
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n;
for(int i=1;i<=n;i++) cin>>a[i];
for(int i=1;i<n;i++)
{
    int u,v;
    cin>>u>>v;
    adj[u].push_back(v);
    adj[v].push_back(u);
}

int mx=(*max_element(a+1,a+n+1));
sieve(mx);

for(int i=1;i<=n;i++)
{
    int x=a[i];
    while(x>1)
    {
        int d=lp[x];
        v[d].push_back(i);
        while(lp[x]==d) x/=d;
    }
}

int root=1;

par[root]=0;
depth[root]=1;
dfs(root); t--;

pw[1]=0;
for(int i=2;i<=t;i++)
{
    pw[i]=pw[i/2]+1;
}

for(int i=1;i<=t;i++) spt[i][0]=order[i];
for(int i=1;(1<<i)<=t;i++)
{
    for(int j=1;j<=t;j++)
    {
        if((j+(1<<(i-1)))>t) break;
        spt[j][i]=min(spt[j][i-1], spt[j+(1<<(i-1))][i-1]);
    }
}

//for(int i=1;i<=2*n;i++) cout<<order[i]<<" "; cout<<endl;


int bl=400;

for(int i=2;i<=mx;i++)
{
    if(v[i].size()<2) continue;

    if(v[i].size()<bl)
    {
        for(int j=0;j<v[i].size();j++)
        {
            for(int k=j+1;k<v[i].size();k++)
            {
                ans=max(ans, dist(v[i][j], v[i][k]));
            }
        }
    }
    else
    {
        divs=i;
        dfs2(root);
    }
}

cout<<ans<<endl;

return 0;
}
